#
# 第5章
# 決定木クラスター分析
#

## 5.1
data(Titanic)
str(Titanic)

Titanic[,1,2,]

#モザイクプロット
mosaicplot(Titanic[,1,2,],color=T)

install.packages("epitools")
library(epitools)
Titanic.df <- expand.table(Titanic)
library(rpart)
Titanic.tree <- rpart(Survived ~ ., data = Titanic.df, method = "class")

summary(Titanic.tree)

install.packages("partykit")
library(partykit)
plot(as.party(Titanic.tree))

plotcp(Titanic.tree)

Titanic.tree2 <- rpart(Survived ~ ., data = Titanic.df, method = "class", cp=0.083)
summary(Titanic.tree2)
plot(as.party(Titanic.tree2))

## 5.2
library(ggplot2)
data(diamonds)

diamonds2 <- subset(diamonds, 
        subset = carat >=1.5 & carat < 2 & clarity %in% c("I1", "SI2"))
boxplot(diamonds2$price)

str(diamonds)

diamonds.tree <- rpart(formula=price ~ carat + cut + color + clarity,
                       data=diamonds, method="anova")

plot(as.party(diamonds.tree))

train <- diamonds[1:50000,]
test <- diamonds[50001:nrow(diamonds),]
diamonds.tree2 <- rpart(
  formula=price ~ carat + cut + color + clarity,
  data=train, method="anova", cp = 0.078)
p <- predict(diamonds.tree2, newdata = test)
head(p)
