#
# 第6章
# サポートベクターマシン(SVM)
#

# 6.2 
spambase <- read.csv("spambase.data", header=F)
colnames(spambase) <- read.table("spambase.names",
                        skip=33,sep=":", comment.char = "")[,1]
colnames(spambase)[ncol(spambase)] <- "spam"
class(spambase$spam)
spambase$spam <- as.factor(spambase$spam)
class(spambase$spam)
dim(spambase)

set.seed(1234)
samp <- sample(4601,2500)
spambase.train <- spambase[samp,]
spambase.test <- spambase[-samp,]

install.packages("kernlab")
library(kernlab)

spambase.svm1 <- ksvm(spam~.,data=spambase.train)
spambase.svm1

ksvm(spam~.,data=spambase.train, kernel="rbfdot",
      kpar=list(sigma=0.01))


library(dplyr)
spambase.train.pre <- predict(spambase.svm1,
                          select(spambase.train,-spam)) 
(spambase.train.svmt <- table(
   data.frame(select(spambase.train,spam),spambase.train.pre)))
spambase.train.pre
1-sum(diag(spambase.train.svmt)/sum(spambase.train.svmt))

spambase.test.pre <- predict(spambase.svm1,
                               select(spambase.test,-spam))

(spambase.test.svmt <- table(
   data.frame(select(spambase.test,spam),spambase.test.pre)))
1-sum(diag(spambase.test.svmt)/sum(spambase.test.svmt))

(spambase.cv <- ksvm(spam~.,data=spambase,kernel="rbfdot",
                       kpar=list(sigma=0.05), C=5,cross=10))
#計算時間かかります

## 6.3
library(ggplot2)
data(diamonds)

diamonds.data <- select(diamonds,carat:clarity,price)
summary(diamonds.data)

set.seed(1234)  #再現性のために乱数のシードを設定
samp2 <- sample(53940,30000) 
diamonds.train <- diamonds.data[samp2,]
diamonds.test <- diamonds.data[-samp2,]

(diamonds.svm <- ksvm(price~.,data=diamonds.train)) 
#計算時間かかります

diamonds.pre <- predict(
   diamonds.svm, select(diamonds.test,-price))
cor(data.frame(diamonds.test$price,diamonds.pre))

diamonds.svghat <- data.frame(
   y=diamonds.test$price,yhat=diamonds.pre)
mean((diamonds.svghat$y-diamonds.svghat$yhat)^2)

