#
# 第7章
# 記憶ベース推論
#

# 7.1

ws.customer <- read.csv("Wholesale customers data.csv")
ws.customer$Channel <- factor(ws.customer$Channel,
                                 labels=c("Horeca","Retail"))
ws.customer$Region <- factor(ws.customer$Region,
                                labels=c("Lisbon","Oporto","Other Region"))
summary(ws.customer)

plot(ws.customer[,3:8],col=(ws.customer$Region))
plot(ws.customer[,3:8],col=ws.customer$Region, 
     pch=as.numeric(ws.customer$Region))

#
set.seed(123456) # 原稿とは異なる#
#
sampA<-sample(1:440,220)
table(ws.customer[sampA,2])
sampB<-(1:440)[-sampA] #sampA以外
table(ws.customer[sampB,2])

library(class)
wsc.knn <- knn(ws.customer[sampA,3:8],ws.customer[sampB,3:8], 
               ws.customer[sampA,2], k=3)

table(wsc.knn,ws.customer[sampB,2])

sqrt(220)
mcrate<-numeric(20)
for (i in 3:20){
  wsc.knn <- knn(ws.customer[sampA,3:8],ws.customer[sampB,3:8], 
                 ws.customer[sampA,2],k=i)
  cr<-table(wsc.knn,ws.customer[sampB,2])
  mcrate[i]<-(sum(cr)-sum(diag(cr)))/sum(cr)
}
plot(3:20,mcrate[3:20],type="l")
which(mcrate==min(mcrate[3:15]))
mcrate[which(mcrate==min(mcrate[3:15]))]
# 結果は実行時の乱数の関係で若干異なります

## 7.2 
normalize <- function(x){
  return ((x-min(x))/(max(x)-min(x))) }
ws.customer.n<-ws.customer
ws.customer.n[,3]<-normalize(ws.customer[,3])
summary(ws.customer.n[,3])

for(i in 4:8){
  ws.customer.n[,i]<-normalize(ws.customer[,i])
}
wsc.knn.n <- knn(ws.customer.n[sampA,3:8], 
                 ws.customer.n[sampB,3:8], 
                 ws.customer.n[sampA,2], k=15)
table(wsc.knn.n,ws.customer.n[sampB,2])
cr<-table(wsc.knn.n,ws.customer.n[sampB,2])
(sum(cr)-sum(diag(cr)))/sum(cr)

