#
# 8
# NX^[
#

download.file("http://goo.gl/t6prX1","xoH21.csv")
cons <- read.csv("xoH21.csv", row.names=1)

head(cons[,1:7])


library(dplyr)
cons.p <- (cons %>% dplyr::select(:̎) %>%
  sweep(., 1, cons$xo, "/")) * 100

cons.std <- scale(cons.p)
cons.dist <- dist(cons.std)
as.matrix(cons.dist)[1:5,1:5]

cons.hclust <- hclust(cons.dist, method="ward.D2")
str(cons.hclust)
head(cons.hclust$merge, n=10)

plot(cons.hclust)
rect.hclust(cons.hclust,k=6)

(cons.cnum <- cutree(cons.hclust, k=6))

# dendextend

install.packages("dendextend")
library(dendextend)
install.packages("colorspace")
library(colorspace)

cons.dend <- as.dendrogram(cons.hclust)
cons.dend <- color_branches(cons.dend, k=6)

labels_colors(cons.dend) <- 
  rainbow_hcl(6)[
    sort_levels_values(
      cons.cnum[order.dendrogram(cons.dend)]
    )
  ]

plot(cons.dend)

# q[g}bv

install.packages("gplots")
library(gplots)

heatmap.2(cons.std,
          main="xof[^̃q[g}bv",
          dendrogram="row",
          Rowv=cons.dend,
          Colv=FALSE,
          col=diverge_hcl(256),
          RowSideColors=labels_colors(cons.dend)[
            order(order.dendrogram(cons.dend))]
)

# k-means

set.seed(100)
cons.km <- kmeans(cons.std, centers=6)

tapply(row.names(cons), cons.km$cluster, unique)

install.packages("GGally")
library(GGally)
library(ggplot2)
cons.km.df <- as.data.frame(cbind(cons.std,
                                  cluster=cons.km$cluster))
cons.km.df$cluster <- factor(cons.km.df$cluster)
ggparcoord(cons.km.df, columns=1:30, groupColumn="cluster") +
  facet_wrap(~cluster) + coord_flip() + theme_bw()

# tmapŃRvX}

install.packages("tmap")
library(tmap)

jpn <- read_shape("JPN_adm1.shp", encoding="UTF-8", use_iconv=TRUE)
head(jpn@data)

jpn@data <- cbind(jpn@data,
                  cluster=factor(
                    cons.km$cluster[as.character(jpn@data$NL_NAME_1)]
                  ))
library(sp)
jpn <- spTransform(jpn, CRS("+proj=merc"))
tm_shape(jpn) +
  tm_fill("cluster", palette = rainbow_hcl(6)) +
  tm_borders()
