#
# 第9章
# 自己組織化マップ
#

# 9.2
shohi<-read.csv("消費支出H21.csv",row.names=1)
summary(shohi)
library(dplyr)
sakerui<-select(shohi,清酒,焼ちゅう,ビール,ウィスキー,ワイン,
                発泡酒.ビール風アルコール飲料,他の酒)
head(sakerui)

library(class)
#
set.seed(1234) # 原稿では設定せず
#
som.g <- somgrid(topo = "hexagonal", xdim=5, ydim=4)
sake.som <- SOM(sakerui, som.g)
sake.som

plot(sake.som)
symbols(sake.som$grid$pts[,1:2],circles=c(rep(0.5, 20)),
        inches = FALSE,add = TRUE)

segment<-as.numeric(knn(sake.som$codes,sakerui, 1:20))
jitter<- cbind(rnorm(nrow(sakerui),0, 0.15),
               rnorm(nrow(sakerui),0, 0.15))
som.new<-sake.som$grid$pts[segment,] +jitter
points(som.new)

table(segment)

text(sake.som$grid$pts[,1]-0.3,sake.som$grid$pts[,2]+0.35,1:20)

boxplot(sakerui[segment==5,],main="ユニット5")
boxplot(sakerui[segment==10,],main="ユニット10")
boxplot(sakerui[segment==14,],main="ユニット14")
boxplot(sakerui[segment==15,],main="ユニット15")
boxplot(sakerui[segment==20,],main="ユニット20")
matome <- c(segment==3|segment==4|segment==9|
                segment==10|segment==14|segment==19)
boxplot(sakerui[matome,],main="ユニット3, 4, 9, 10, 14, 19")

install.packages("kohonen")
install.packages("latticeExtra")
install.packages("deldir")
library("kohonen")
library("latticeExtra")
library("deldir")
sake.som.df <- as.data.frame(cbind (sake.som$grid$pts, sake.som$codes))
levelplot(清酒~ x * y, data = sake.som.df,
            panel = panel.voronoi, aspect = "iso",main="清酒")
levelplot(焼ちゅう~ x * y, data = sake.som.df,
              panel = panel.voronoi, aspect = "iso",main="焼酎")
levelplot(ビール~ x * y, data = sake.som.df,
             panel = panel.voronoi, aspect = "iso",main="ビール")
levelplot(ウィスキー~ x * y, data = sake.som.df,
               panel = panel.voronoi, aspect = "iso",main="ウィスキー")
levelplot(ワイン~ x * y, data = sake.som.df,
             panel = panel.voronoi, aspect = "iso",main="ワイン")
levelplot(発泡酒. ビール風アルコール飲料~ x * y, data = sake.som.df,
             panel = panel.voronoi, aspect = "iso",main="発泡酒")
levelplot(他の酒~ x * y, data = sake.som.df, panel = panel.voronoi,
             aspect = "iso",main="その他の酒")

## 9.3
ws.customer <- read.csv("Wholesale customers data.csv")
head(ws.customer)
#
set.seed(1234) # 原稿とは異なる
#
som.g2 <- somgrid(topo = "hexagonal", xdim=8, ydim=6)
wsc.som <- SOM(ws.customer, som.g2)
plot(wsc.som)
symbols(wsc.som$grid$pts[,1:2],circles=c(rep(0.5, 48)),inches = FALSE,add = TRUE)
seg2<-as.numeric(knn(wsc.som$codes,ws.customer, 1:48))
jitter<- cbind(rnorm(nrow(ws.customer),0, 0.15), rnorm(nrow(ws.customer),0, 0.15))
wsc.new<-wsc.som$grid$pts[seg2,] +jitter
points(wsc.new)
text(wsc.som$grid$pts[,1]-0.3,wsc.som$grid$pts[,2]+0.35,1:48)

plot(wsc.som)
symbols(wsc.som$grid$pts[,1:2],circles=c(rep(0.5, 48)),inches = FALSE,add = TRUE)
points(wsc.new,col=c(2:3)[unclass(ws.customer$Channel)],pch=c(1:2)[unclass(ws.customer$Channel)])
text(wsc.som$grid$pts[,1]-0.3,wsc.som$grid$pts[,2]+0.35,1:48)

wsc.som.df <- as.data.frame(cbind (wsc.som$grid$pts, wsc.som$codes))
levelplot(Channel ~ x * y, data = wsc.som.df,
          panel = panel.voronoi, aspect = "iso",main="Channel")
table(ws.customer$Channel)
table(as.numeric(ws.customer$Channel))
levelplot(Region ~ x * y, data = wsc.som.df,
          panel = panel.voronoi, aspect = "iso",main="Region")
table(ws.customer$Region)

levelplot(Fresh ~ x * y, data = wsc.som.df,
          panel = panel.voronoi, aspect = "iso",main="Fresh")
levelplot(Milk ~ x * y, data = wsc.som.df,
          panel = panel.voronoi, aspect = "iso",main="Milk")
levelplot(Grocery ~ x * y, data = wsc.som.df,
          panel = panel.voronoi, aspect = "iso",main="Grocery")
levelplot(Frozen ~ x * y, data = wsc.som.df,
          panel = panel.voronoi, aspect = "iso",main="Frozen")
levelplot(Detergents_Paper ~ x * y, data = wsc.som.df,
          panel = panel.voronoi, aspect = "iso",main="Detergents_Paper")
levelplot(Delicassen ~ x * y, data = wsc.som.df,
          panel = panel.voronoi, aspect = "iso",main="Delicassen")

