#
# chapter 13
#
spambase <- read.csv("spambase.data", header=F)
colnames(spambase) <- read.table("spambase.names", skip=33,
                                 sep=":", comment.char = "")[,1]
colnames(spambase)[ncol(spambase)] <- "spam"
spambase$spam<-as.factor(spambase$spam)

dim(spambase)
set.seed(1234)
samp<-sample(4601,2500)
spambase.train<-spambase[samp,]
spambase.test<-spambase[-samp,]

spambase.glm <- glm(spam~., data=spambase.train,
                    family="binomial")
spambase.glm.pre <- round(predict(spambase.glm, type="resp"),0)
(spambase.glm.tb <-table(spam=spambase.train$spam,
                         pred=round(spambase.glm.pre,0)))
1-sum(diag(spambase.glm.tb)/sum(spambase.glm.tb))

spambase.glm.testpre <-
   round(predict(spambase.glm, spambase.test, type="resp"),0)
(spambase.glm.test.tb <-table(spam=spambase.test$spam,
                              pred=round(spambase.glm.testpre,0)))
1-sum(diag(spambase.glm.test.tb)/sum(spambase.glm.test.tb))

summary(spambase.glm)

library("MASS")  
spambase.glmstep <- stepAIC(spambase.glm, direction=c("both"))
#時間がかかります
summary(spambase.glmstep)

spambase.glmstep.pre <- predict(spambase.glmstep, type="resp")
(spambase.glmstep.tb <-table(spam=spambase.train$spam,
                             pred=round(spambase.glmstep.pre,0)))
1-sum(diag(spambase.glmstep.tb)/sum(spambase.glmstep.tb))
spambase.glmstep.testpre <-
  round(predict(spambase.glmstep, spambase.test, type="resp"),0)
(spambase.glmstep.tb1 <-
  table(spam=spambase.test$spam,
        pred=round(spambase.glmstep.testpre,0)))
1-sum(diag(spambase.glmstep.tb1)/sum(spambase.glmstep.tb1))

## 13.2.2
library(rpart)
library(partykit)
spambase.rp <- rpart(spam~., data=spambase.train)
print(spambase.rp,digit=2)

spambase.rp.pre <- predict(spambase.rp,type="class")
(spambase.rp.tb <-table(spam=spambase.train$spam,
                        pred=spambase.rp.pre))
1-sum(diag(spambase.rp.tb)/sum(spambase.rp.tb))
spambase.rp.testpre <- predict(spambase.rp,
                               spambase.test, type="class")
(spambase.rp.test.tb <-
  table(spam=spambase.test$spam,pred=spambase.rp.testpre))
1-sum(diag(spambase.rp.test.tb)/sum(spambase.rp.test.tb))

## 13.2.3
library(kernlab)
spambase.svm <- ksvm(spam~.,data=spambase.train)
spambase.trainp <- predict(spambase.svm,
            dplyr::select(spambase.train,-spam))
(spambase.svm.traintb <-
  table(spam=spambase.train$spam,pred=spambase.trainp))
1-sum(diag(spambase.svm.traintb)/sum(spambase.svm.traintb))
spambase.svm.test.pre <- predict(spambase.svm, 
                              dplyr::select(spambase.test,-spam))
(spambase.svm.testtb <-
  table(spam=spambase.test$spam,pred=spambase.svm.test.pre))
1-sum(diag(spambase.svm.testtb)/sum(spambase.svm.testtb))


### 13.3
library(ggplot2)
data(diamonds)
diamonds.data<-dplyr::select(diamonds,carat:clarity,price)
dim(diamonds)

## 13.3.1
set.seed(1234)
samp2<-sample(53940,30000)
diamonds.train<-diamonds.data[samp2,]
diamonds.test <-diamonds.data[-samp2,]
diamonds.train.lm <- lm(price~., data=diamonds.train)
summary(diamonds.train.lm)

AIC(diamonds.train.lm)
mean(abs(diamonds.train.lm$residual))

diamonds.trainlm.testp <-
  predict(diamonds.train.lm,diamonds.test)
cor(diamonds.test$price,diamonds.trainlm.testp)
perror <- diamonds.test$price-diamonds.trainlm.testp
mean(abs(perror))

diamonds.train.lmstep <-
  stepAIC(diamonds.train.lm,direction="both")
diamonds.train.lmstep

## 13.3.2
diamonds.train.rp <- rpart(price~., data=diamonds.train)
print(diamonds.train.rp,digit=2)
plot(as.party(diamonds.train.rp))

diamonds.train.rp.pre <- predict(diamonds.train.rp)
plot(diamonds.train.rp.pre-diamonds.train$price)
mean(abs(diamonds.train.rp.pre-diamonds.train$price))
diamonds.train.rp.testp <-
  predict(diamonds.train.rp,diamonds.test)
plot(diamonds.train.rp.testp-diamonds.test$price)
mean(abs(diamonds.train.rp.testp-diamonds.test$price))

## 13.3.3
diamonds.train.svm <- ksvm(price~., data=diamonds.train)
diamonds.train.svm.pre <-predict(diamonds.train.svm,
                      dplyr::select(diamonds.train,-price))
plot(diamonds.train.svm.pre-diamonds.train$price)
mean(abs(diamonds.train.svm.pre-diamonds.train$price))
diamonds.train.svm.testp <-
  predict(diamonds.train.svm,dplyr::select(diamonds.test,-price))
plot(diamonds.train.svm.testp-diamonds.test$price)
mean(abs(diamonds.train.svm.testp-diamonds.test$price))

