library(XML)
library(RFinanceYJ)
quote.url <- "http://info.finance.yahoo.co.jp/history/?code=998407&sy=2015&sm=8&sd=1&ey=2015&em=8&ed=31&tm=d"
t <- readHTMLTable(quote.url)
nikkei <- t[[2]]

nikkei.date <- as.character(nikkei[,1])
nikkei.date <- as.Date(nikkei.date, format="%YN%m%d")
nikkei <- as.numeric(sub(",","", nikkei[,5]))
plot(nikkei.date, nikkei, type="l")

dat <- read.csv("data/n225all.csv", header=TRUE)
dat[1:5, 1:5]
date <- sub("X", "", colnames(dat)[-1])
code <- dat[,1]
dat <- t(dat[,-1])
dat <- matrix(as.numeric(sub(",","", as.character(dat))),,225)
rownames(dat) <- date
colnames(dat) <- code
dat[1:5, 1:5]

hist(cor(dat), xlab = "Correlation", main = "Histgram of correlations")

n225.pca <- princomp(dat, cor=TRUE)
vars<- n225.pca$sd^2
props<- vars/225
cumsum(props)[1:5]
screeplot(n225.pca, npcs=5)
hist(n225.pca$loadings[,1], xlab = "Loading")

n225 <- read.csv("data/n225.csv")
pca.prd <- predict(n225.pca)[,1]
n225 <- transform(n225, pca.prd = pca.prd)
head(n225)
plot(n225[,4:3], xlab="Market index (PCA)", ylab="Nikkei 225")

rslt <- data.frame(date = rev(as.Date(n225$date, format="%Y/%m/%d")),
                   nikkei = rev(n225$nikkei),
                   pca.prd = - rev(pca.prd)
                   )
plot(rslt[,c(1,2)], type = "l", ylab = "", col = 'red')
par(new =TRUE)
plot(rslt[,c(1,3)], type = "l", axes = FALSE, ylab = "", col = 'blue')
axis(4)
labels <- c("nikkei","pca.prd")
legend("topleft", legend = labels, col = c(2,4), lty = 1)
